struct edit_view_param
{
	string8 value;
};

static BOOL CALLBACK EditViewProc(HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		uSetWindowLong(wnd,DWL_USER,lp);
		{
			edit_view_param * ptr = reinterpret_cast<edit_view_param*>(lp);
			uSetDlgItemText(wnd,IDC_VALUE,ptr->value);
		}
		break;
	case WM_COMMAND:
		switch(wp)
		{
		case IDCANCEL:
			EndDialog(wnd,0);
			break;
		case IDOK:
			{
				edit_view_param * ptr = reinterpret_cast<edit_view_param*>(uGetWindowLong(wnd,DWL_USER));
				uGetDlgItemText(wnd,IDC_VALUE,ptr->value);
				EndDialog(wnd,1);

			}
			break;			
		}
		break;
	}
	return FALSE;
}

static bool run_edit_view(edit_view_param & param,HWND parent)
{
	return !!uDialogBox(IDD_EDIT_VIEW,parent,EditViewProc,reinterpret_cast<LPARAM>(&param));
}

static bool albumart_config_initialized=false;
class albumart_config : public config
{
private:
	static BOOL CALLBACK DialogProc(HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
	{
		switch(msg)
		{
		case WM_DESTROY:
			albumart_config_initialized=false;
			break;
		case WM_INITDIALOG:
			{
				HWND list = uGetDlgItem(wnd,IDC_List);
				unsigned n,m = cfg_src_list.get_count();
				string8_fastalloc temp;
				for(n=0;n<m;n++)
				{
					cfg_src_list.format_display(n,temp);
					uSendMessageText(list,LB_ADDSTRING,0,temp);
				}
			}
			{
				HWND list = uGetDlgItem(wnd,IDC_LftClick);
				for(int i=0;i<tabsize(func_name);i++)
					uSendMessageText(list,CB_ADDSTRING,0,func_name[i]);
				uSendMessage(list,CB_SETCURSEL,cfg_lftclickfunc,0);
			}
			{
				HWND list = uGetDlgItem(wnd,IDC_MdlClick);
				for(int i=0;i<tabsize(func_name);i++)
					uSendMessageText(list,CB_ADDSTRING,0,func_name[i]);
				uSendMessage(list,CB_SETCURSEL,cfg_mdlclickfunc,0);
			}
			{
				HWND list = uGetDlgItem(wnd,IDC_DblClick);
				for(int i=0;i<tabsize(func_name);i++)
					uSendMessageText(list,CB_ADDSTRING,0,func_name[i]);
				uSendMessage(list,CB_SETCURSEL,cfg_dblclickfunc,0);
			}
			{
				HWND list = uGetDlgItem(wnd,IDC_Quality);
				uSendMessageText(list,CB_ADDSTRING,0,"Low");
				uSendMessageText(list,CB_ADDSTRING,0,"Mediocre");
				uSendMessageText(list,CB_ADDSTRING,0,"High");
				uSendMessageText(list,CB_ADDSTRING,0,"Highest");
				uSendMessage(list,CB_SETCURSEL,cfg_interpolationmode,0);
			}

			SetDlgItemInt(wnd,IDC_MinHeight,cfg_minheight,FALSE);
			uSendDlgItemMessage(wnd,IDC_MinHeight_Spin,UDM_SETRANGE32,0,999);

			SetDlgItemInt(wnd,IDC_Padding,cfg_padding,TRUE);
			uSendDlgItemMessage(wnd,IDC_Padding_Spin,UDM_SETRANGE32,-999,999);

			uSendDlgItemMessage(wnd,IDC_Center,BM_SETCHECK,cfg_centeralbum,0);
			uSendDlgItemMessage(wnd,IDC_Expand,BM_SETCHECK,cfg_expandalbum,0);
			uSendDlgItemMessage(wnd,IDC_Shrink,BM_SETCHECK,cfg_shrinkalbum,0);
			uSendDlgItemMessage(wnd,IDC_Selected,BM_SETCHECK,cfg_selected,0);
			uSendDlgItemMessage(wnd,IDC_UseBG,BM_SETCHECK,cfg_usebg,0);
			uSendDlgItemMessage(wnd,IDC_AspectRatio,BM_SETCHECK,cfg_aspectratio,0);
			uSendDlgItemMessage(wnd,IDC_PixelBorder,BM_SETCHECK,cfg_pixelborder,0);
			uSendDlgItemMessage(wnd,IDC_UseControl,BM_SETCHECK,cfg_usecontrol,0);
			uSendDlgItemMessage(wnd,IDC_ResetSource,BM_SETCHECK,cfg_resetsource,0);

			albumart_config_initialized=true;

			return 1;
		case WM_COMMAND:
			switch(wp)
			{
			case IDC_Center:
				cfg_centeralbum = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_Expand:
				cfg_expandalbum = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_Shrink:
				cfg_shrinkalbum = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_Selected:
				cfg_selected = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_UseBG:
				cfg_usebg = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_ChooseBG:
				color_picker(wnd,cfg_bgcol);
				break;
			case IDC_AspectRatio:
				cfg_aspectratio = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_PixelBorder:
				cfg_pixelborder = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_UseControl:
				cfg_usecontrol = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_ResetSource:
				cfg_resetsource = uSendMessage((HWND)lp,BM_GETCHECK,0,0);
				break;
			case IDC_MinHeight | (EN_CHANGE<<16):
				{
					if(albumart_config_initialized){
						BOOL result;
						unsigned new_height = GetDlgItemInt(wnd, IDC_MinHeight, &result, FALSE);
						if (result)
							cfg_minheight = new_height>999?999:new_height;
					}
				}
				break;
			case IDC_Padding | (EN_CHANGE<<16):
				{
					if(albumart_config_initialized){
						BOOL result;
						int new_padding = GetDlgItemInt(wnd, IDC_Padding, &result, TRUE);
						if (result)
							cfg_padding = new_padding>999?999: new_padding<-999?-999: new_padding;
					}
				}
				break;
			case IDC_MdlClick | (CBN_SELCHANGE<<16):
				cfg_mdlclickfunc = uSendMessage((HWND)lp,CB_GETCURSEL,0,0);
				break;
			case IDC_LftClick | (CBN_SELCHANGE<<16):
				cfg_lftclickfunc = uSendMessage((HWND)lp,CB_GETCURSEL,0,0);
				break;
			case IDC_DblClick | (CBN_SELCHANGE<<16):
				cfg_dblclickfunc = uSendMessage((HWND)lp,CB_GETCURSEL,0,0);
				break;
			case IDC_Quality | (CBN_SELCHANGE<<16):
				cfg_interpolationmode = uSendMessage((HWND)lp,CB_GETCURSEL,0,0);
				break;
			case IDC_List | (LBN_DBLCLK<<16):
				{
					HWND list = (HWND)lp;
					unsigned idx = uSendMessage(list,LB_GETCURSEL,0,0);
					if (idx != (unsigned)(-1))
					{
						edit_view_param p;
						p.value = cfg_src_list.get_value(idx);
						if (run_edit_view(p,wnd))
						{
							string8 temp;
							cfg_src_list.modify_item(idx,p.value);
							cfg_src_list.format_display(idx,temp);
							uSendMessage(list,LB_DELETESTRING,idx,0);
							uSendMessageText(list,LB_INSERTSTRING,idx,temp);
							uSendMessageText(list,LB_SETCURSEL,idx,0);
						}
					}
				}
				break;
			case IDC_Up:
				{
					HWND list = uGetDlgItem(wnd,IDC_List);
					unsigned idx = uSendMessage(list,LB_GETCURSEL,0,0);
					if (idx != (unsigned)(-1) && idx>0)
					{
						uSendMessage(list,LB_DELETESTRING,idx,0);
						cfg_src_list.swap(idx,idx-1);
						string8 temp;
						cfg_src_list.format_display(idx-1,temp);
						uSendMessageText(list,LB_INSERTSTRING,idx-1,temp);
						uSendMessage(list,LB_SETCURSEL,idx-1,0);
					}
				}
				break;
			case IDC_Down:
				{
					HWND list = uGetDlgItem(wnd,IDC_List);
					unsigned idx = uSendMessage(list,LB_GETCURSEL,0,0);
					if (idx != (unsigned)(-1) && idx+1<cfg_src_list.get_count())
					{
						uSendMessage(list,LB_DELETESTRING,idx,0);
						cfg_src_list.swap(idx,idx+1);
						string8 temp;
						cfg_src_list.format_display(idx+1,temp);
						uSendMessageText(list,LB_INSERTSTRING,idx+1,temp);
						uSendMessage(list,LB_SETCURSEL,idx+1,0);
					}
				}
				break;
			case IDC_Remove:
				{
					HWND list = uGetDlgItem(wnd,IDC_List);
					unsigned idx = uSendMessage(list,LB_GETCURSEL,0,0);
					if (idx != (unsigned)(-1))
					{
						cfg_src_list.remove_item(idx);
						uSendDlgItemMessage(wnd,IDC_List,LB_DELETESTRING,idx,0);
					}
				}
				break;
			case IDC_Add:
				{
					edit_view_param p;
					if (run_edit_view(p,wnd))
					{
						HWND list = uGetDlgItem(wnd,IDC_List);
						unsigned n = cfg_src_list.add_item(p.value);
						string8 temp;
						cfg_src_list.format_display(n,temp);
						uSendMessageText(list,LB_ADDSTRING,0,temp);
						uSendMessage(list,LB_SETCURSEL,n,0);
					}
				}
				break;
			case IDC_Reset:
				{
					cfg_src_list.reset();
					HWND list = uGetDlgItem(wnd,IDC_List);
					uSendMessage(list,LB_RESETCONTENT,0,0);
					unsigned n,m = cfg_src_list.get_count();
					string8_fastalloc temp;
					for(n=0;n<m;n++)
					{
						cfg_src_list.format_display(n,temp);
						uSendMessageText(list,LB_ADDSTRING,0,temp);
					}
				}
				break;
			}
			break;
			
		}
		return 0;
	}
public:
	HWND create(HWND parent)
	{
		return uCreateDialog(IDD_ALBUMART_CONFIG,parent,DialogProc);
	}
	const char * get_name() {return "Album Art Panel";}
	const char * get_parent_name() {return "Components";}
};

static service_factory_t<config,albumart_config> foo_uie_albumart_config;