enum
{
	WM_FOO_CALLBACK = WM_USER,
	PLAYLIST_FOCUS_CHANGE=0,
	PLAYBACK_NEW_TRACK,
	PLAYBACK_STOP,
	VARIABLE_CHANGE,
	APP_INIT,
	APP_QUIT,
};

class albumart_var_notify : public cfg_var_notify
{
private:
	mem_block_list_t<HWND> hwnds;
public:
	void add_window(HWND wnd) { hwnds.add_item(wnd); }
	void remove_window(HWND wnd) { hwnds.remove_item(wnd); }
	virtual void on_var_change(const char * name, cfg_var * var)
	{
		int i, n = hwnds.get_count();
		for (i = 0; i<n; i++)
			SendMessage(hwnds[i],WM_FOO_CALLBACK,VARIABLE_CHANGE,(long)(var));
	}
	albumart_var_notify(cfg_var * var1) : cfg_var_notify(var1) {}
	~albumart_var_notify(){}
};

class albumart_playback_notify : public play_callback
{
private:
	mem_block_list_t<HWND> hwnds;
public:
	void add_window(HWND wnd) { hwnds.add_item(wnd); }
	void remove_window(HWND wnd) { hwnds.remove_item(wnd); }
	virtual unsigned get_callback_mask() {
		return MASK_on_playback_new_track | MASK_on_playback_stop;
	}
	virtual void on_playback_new_track(metadb_handle * track) {
		int i, n = hwnds.get_count();
		for (i = 0; i<n; i++)
			SendMessage(hwnds[i],WM_FOO_CALLBACK,PLAYBACK_NEW_TRACK,(long)track);
	}
	virtual void on_playback_stop(play_control::stop_reason reason) {
		int i, n = hwnds.get_count();
		for (i = 0; i<n; i++)
			SendMessage(hwnds[i],WM_FOO_CALLBACK,PLAYBACK_STOP,(long)reason);
	}
	virtual void on_playback_starting() {}
	virtual void on_playback_time(metadb_handle * track,double val) {}
	virtual void on_playback_seek(double time) {}
	virtual void on_playback_pause(int state) {}
	virtual void on_playback_edited(metadb_handle * track) {}
	virtual void on_playback_dynamic_info(const file_info * info,bool b_track_change) {}
	virtual void on_volume_change(int new_val) {}
};

class albumart_playlist_notify : public playlist_callback
{
private:
	mem_block_list_t<HWND> hwnds;
public:
	void add_window(HWND wnd) { hwnds.add_item(wnd); }
	void remove_window(HWND wnd) { hwnds.remove_item(wnd); }
	virtual void on_focus_change(int from,int to)
	{
		int i, n = hwnds.get_count();
		for (i = 0; i<n; i++)
			SendMessage(hwnds[i],WM_FOO_CALLBACK,PLAYLIST_FOCUS_CHANGE,to);
	}
	virtual void on_items_added(int start, int count) {}
	virtual void on_order(const int * order,int count) {}
	virtual void on_items_removing(const bit_array & mask) {}
	virtual void on_items_removed(const bit_array & mask) {}
	virtual void on_sel_change(int idx,bool state) {}
	virtual void on_sel_change_multi(const bit_array & before,const bit_array & after,int count) {}
	virtual void on_modified(int idx) {}
};

static albumart_var_notify foo_uie_albumart_src_list_notify(&cfg_src_list);
static albumart_var_notify foo_uie_albumart_centeralbum_notify(&cfg_centeralbum);
static albumart_var_notify foo_uie_albumart_expandalbum_notify(&cfg_expandalbum);
static albumart_var_notify foo_uie_albumart_shrinkalbum_notify(&cfg_shrinkalbum);
static albumart_var_notify foo_uie_albumart_selected_notify(&cfg_selected);
static albumart_var_notify foo_uie_albumart_usebg_notify(&cfg_usebg);
static albumart_var_notify foo_uie_albumart_bgcol_notify(&cfg_bgcol);
static albumart_var_notify foo_uie_albumart_aspectratio_notify(&cfg_aspectratio);
static albumart_var_notify foo_uie_albumart_pixelborder_notify(&cfg_pixelborder);
static albumart_var_notify foo_uie_albumart_interpolationmode_notify(&cfg_interpolationmode);
static albumart_var_notify foo_uie_albumart_usecontrol_notify(&cfg_usecontrol);
static albumart_var_notify foo_uie_albumart_minheight_notify(&cfg_minheight);
static albumart_var_notify foo_uie_albumart_resetsource_notify(&cfg_resetsource);
static albumart_var_notify foo_uie_albumart_padding_notify(&cfg_padding);

static service_factory_single_transparent_t<playlist_callback,albumart_playlist_notify> foo_uie_albumart_playlist_notify;
static service_factory_single_transparent_t<play_callback,albumart_playback_notify>		foo_uie_albumart_playback_notify;